﻿var vo = {};
var fs = require ("fs");

function getNS (codes) {
	var s = "";
	for (var i = 0; i < codes.length; i ++) {
		var tokens = codes [i].split (".");
		var n = tokens [0];
		s += n + " = {}; ";
		for (var j = 1; j < tokens.length; j ++) {
			n += "." + tokens [j];
			s += n + " = {}; ";
		};
		s += "\n";
	};
	return s;
};
vo.init = function (options) {
	var success = options.success;
	success ();
};
vo.handler = function (options) {
	var success = options.success;
	success ();
};
vo.parseErrors = function (actions, txt) {
	if (!txt) {
		return;
	};
	var actions = actions.split ("\n");
	var errs = [];
	txt = txt.split ("\r").join ("");
	var lines = txt.split ("\n");
	for (var i = 0; i <= lines.length - 4; i += 4) {
		var e = {
			src: lines [i + 1],
			ptr: lines [i + 2]
		};
		var tokens = lines [i].split ("vo-debug.js:")[1];
		console.log (tokens);
		tokens = tokens.split (":");
		e.line = tokens [0];
		e.msg = tokens [1];
		for (var j = e.line; j >= 0; j --) {
			if (actions [j].indexOf ("__Action:") > -1) {
				tokens = actions [j].split (":");
				var actionCode = tokens [1].split ("(")[1];
				tokens = actions [j - 1].split (":");
				var classCode = tokens [1].split ("(")[1];
				e.action = classCode + "." + actionCode;
				e.line -= j + 3;
				break;
			};
		};
		errs.push (e);
	};
	return errs;
};
vo.build = function (options) {
	var $o = options.objectum;
	var config = $o.config;
	var storage = options.storage;
	var async = $o.modules.async;
	var session = options.session;
	var success = options.success;
	var time1 = (new Date ()).getTime ();
	var rows, codes = [], allClient = "", allServer = "", serverActions, revision, scripts;
	async.series ([
		function (cb) {
			fs.readFile (storage.rootDir + "/config.json", "utf8", function (err, data) {
				scripts = JSON.parse (data).scripts;
				cb ();
			});
		},
		function (cb) {
			if (scripts && scripts.client) {
				async.eachSeries (scripts.client, function (script, cb) {
					fs.readFile (script, "utf8", function (err, data) {
						if (!err) {
							allClient += data + "\n";
						};
						cb ();
					});
				}, function (err) {
					cb ();
				});
			} else {
				cb ();
			};
		},
		function (cb) {
			storage.query ({session: session, sql: 
//				"select fid, fclass_id, fname, fcode, fbody, flayout from taction where (flayout is not null or fbody is not null) and " + storage.getCurrentFilter ()
				"select fid, fclass_id, fname, fcode, fbody, flayout from taction where " + storage.getCurrentFilter ()
			, success: function (options) {
				rows = options.result.rows;
				cb ();
			}});
		},
		function (cb) {
			for (var i = 0; i < rows.length; i ++) {
				var row = rows [i];
				var cls = storage.classesMap [row.fclass_id];
				if (cls) {
					var code = storage.getClassFullCode (cls);
					if (codes.indexOf (code) == -1) {
						codes.push (code);
					};
					row.fbody = row.fbody || "";
					var lines = row.fbody.split ("\n");
					var body = "";
					for (var j = 0; j < lines.length; j ++) {
						body += "\t" + lines [j] + "\n";
					};
					var l;
					try {
						l = JSON.parse (row.flayout);
					} catch (e) {
					};
					if (l && l.serverAction) {
						allServer +=
							"/*\n" +
							"\t__Class: " + cls.get ("fname") + " (" + code + ": " + cls.get ("fid") + ")\n" +
							"\t__Action: " + row.fname + " (" + row.fcode + ": " + row.fid + ")\n" +
							"*/\n" +
							"actions." + code + "." + row.fcode + " = function (options) {\n"
						;
						if (!l.noAuth) {
							allServer +=
								"\tif (!options.session) {\n" +
								"\t\toptions.res.send (401, {header: {error: \"Unauthorized\"}});\n" +
								"\t\treturn;\n" +
								"\t};\n"
							;
						};
						allServer +=
							body +
							"};\n"
						;
						body = 
							"\t$o.execute ({fn: \"actions." + code + "." + row.fcode + "\", success: function (result) {\n" +
							"\t\tif (options && options.success) {\n" +
							"\t\t\toptions.success (result);\n" +
							"\t\t};\n" +
							"\t}});\n"
						;
					};
					allClient +=
						"/*\n" +
						"\t__Class: " + cls.get ("fname") + " (" + code + ": " + cls.get ("fid") + ")\n" +
						"\t__Action: " + row.fname + " (" + row.fcode + ": " + row.fid + ")\n" +
						"*/\n" +
						code + "." + row.fcode + " = function (options) {\n" +
						body +
						"};\n"
					;
					if (l && l.layout) {
						allClient += 
							code + "." + row.fcode + ".layout = " +
							JSON.stringify (l.layout, null, "\t") +
							";\n"
						;
					};
				};
			};
			if (codes.length) {
				var ns = JSON.stringify (codes, null, "\t");
				ns = ns.substr (1, ns.length - 2);
				allClient =
					"Ext.namespace (\n" +
					ns +
					");\n" +
					allClient
				;
				serverActions = config.storages [storage.code].visualObjectum && config.storages [storage.code].visualObjectum.serverActions;
				allServer =
					"var actions = {};\n" +
					"function setNS () {\n" +
					"\tfor (var i = 0; i < arguments.length; i ++) {\n" +
//					"\t\tvar tokens = (\"actions.\" + arguments [i]).split (\".\");\n" +
//					"\t\tvar root = global;\n" +
					"\t\tvar tokens = arguments [i].split (\".\");\n" +
					"\t\tvar root = actions;\n" +
					"\t\tfor (var j = 0; j < tokens.length; j ++) {\n" +
					"\t\t\troot [tokens [j]] = root [tokens [j]] || {};\n" +
					"\t\t\troot = root [tokens [j]];\n" +
					"\t\t};\n" +
					"\t};\n" +
					"};\n" +
					"setNS (" +
					ns +
					");\n" +
					(serverActions ? allServer : "")
				;
			};
			cb ();
		},
		function (cb) {
			fs.writeFile (storage.rootDir + "/resources/scripts/vo-debug.js", allClient, function (err) {
				cb ();
			});
		},
		function (cb) {
			fs.readFile (config.projectsDir + "/app/plugins/vo.js", function (err, data) {
				if (err) {
					cb ();
				} else {
					fs.writeFile (storage.rootDir + "/plugins/vo.js", data, function (err) {
						cb ();
					});
				};
			});
		},
		function (cb) {
			fs.writeFile (storage.rootDir + "/plugins/actions.js", allServer + "\nexports.actions = actions;\n", function (err) {
				config.storages [storage.code].pluginStarted = 0;
				for (var key in require.cache) {
					var tokens = key.split ("/");
					if (tokens.length == 1) {
						tokens = key.split ("\\");
					};
					if (tokens.length > 3 &&
						tokens.indexOf ("plugins") > -1 && (
							tokens.indexOf (storage.code) > -1 || tokens [tokens.length - 1] == "vo.js"
						)
					) {
						delete require.cache [key];
					};
				};
				cb ();
			});
		},
		function (cb) {
			$o.projects.startProjectPlugins ({storage: storage, success: function () {
				vo.getLastRevision ({storage: storage, success: function (options) {
					revision = options.revision;
					cb ();
				}});
			}});
		},
		function (cb) {
			options.success = function () {
				cb ();
			};
			vo.setProjectInfo (options);
		},
		function (cb) {
			options.success = function (options) {
				cb (vo.parseErrors (allClient, options.err));
			};
			vo.setProjectBuild (options);
		}
	], function (err) {
		var time2 = (new Date ()).getTime ();
		success ({time: time2 - time1, serverActions: serverActions, revision: revision, err: err});
	});
};
vo.restart = function (options) {
	var $o = options.objectum;
	var config = $o.config;
	var storage = options.storage;
	var async = $o.modules.async;
	var session = options.session;
	var success = options.success;
	for (sid in $o.projects.sessions) {
		var session = $o.projects.sessions [sid];
		if (session.storage.code = storage.code) {
			storage.redisClient.hdel ('sessions', 
				sid + '-id', sid + '-username', sid + '-clock', sid + '-storageCode', 
				sid + '-newsRevision', sid + "-port", sid + '-userId', sid + '-spaceId', sid + '-logined', sid + '-ip'
			);
			storage.redisClient.incrby ('online-num', -1);
			storage.redisClient.hdel (storage.code + '-online', session.username);
			storage.redisPub.publish ('sessions', '{"removed":"' + sid + '"}');
		};
	};
	storage.freeResources ();
	delete $o.projects.storagePool [storage.code];
	success ({});
};
vo.getLastRevision = function (options) {
	var storage = options.storage;
	var success = options.success;
	storage.query ({sql: "select fid from trevision order by fid desc", success: function (options) {
		var rows = options.result.rows;
		success ({revision: rows [0].fid});
	}});
};
vo.getActions = function (options) {
	var storage = options.storage;
	var success = options.success;
	fs.readFile (storage.rootDir + "/plugins/actions.js", function (err, data) {
		success ({actions: data.toString ("utf8")});
	});
};
vo.getProjectInfo = function (options) {
	var $o = options.objectum;
	var config = $o.config;
	var async = $o.modules.async;
	var storage = options.storage;
	var success = options.success;
	var result = {};
	async.series ([
		function (cb) {
			options.success = function (options) {
				result.revision = options.revision;
				cb ();
			};
			vo.getLastRevision (options);
		},
		function (cb) {
			fs.readFile (storage.rootDir + "/config.json", function (err, data) {
				result.smtp = {};
				try {
					data = JSON.parse (data.toString ("utf8"));
					if (data.smtp) {
						result.smtp = data.smtp;
					};
					if (data.scripts) {
						result.scripts = data.scripts;
					};
				} catch (e) {
				};
				cb ();
			});
		},
		function (cb) {
			fs.readFile (storage.rootDir + "/index.html", function (err, data) {
				data = data.toString ("utf8");
				var tokens = data.split ("$o.app.start");
				var posEnd = tokens [1].indexOf ("})") + 2;
				var r = tokens [1].substr (0, posEnd);
				r = eval (r);
				result.name = r.name;
				cb ();
			});
		}
	], function (err) {
		success (result);
	});
};
vo.setProjectInfo = function (options) {
	var $o = options.objectum;
	var config = $o.config;
	var async = $o.modules.async;
	var storage = options.storage;
	var success = options.success;
	var args = options.args;
	async.series ([
		function (cb) {
			fs.readFile (storage.rootDir + "/index.html", function (err, data) {
				data = data.toString ("utf8");
				var tokens = data.split ("$o.app.start");
				var posEnd = tokens [1].indexOf ("})") + 2;
				var r = tokens [1].substr (0, posEnd);
				r = eval (r);
				r = {
					code: r.code,
					name: args.name,
					version: r.version,
					locale: r.locale,
					visualObjectum: r.visualObjectum
				};
				data = tokens [0] + "$o.app.start (" + JSON.stringify (r) + ")" + tokens [1].substr (posEnd);
				fs.writeFile (storage.rootDir + "/index.html", data, function (err) {
					cb ();
				});
			});
		},
		function (cb) {
			fs.readFile (storage.rootDir + "/config.json", function (err, data) {
				if (err) {
					cb ();
				} else {
					data = JSON.parse (data.toString ("utf8"));
					if (args.password) {
						config.storages [storage.code].adminPassword = args.password;
						data.adminPassword = args.password;
					};
					if (args.smtp && (args.smtp.host.indexOf ("127.0.0.1") > -1 || args.smtp.host.toLowerCase ().indexOf ("localhost") > -1)) {
						args.smtp.host = undefined;
					};
					data.smtp = args.smtp;
					data.scripts = args.scripts;
					data.visualObjectum = data.visualObjectum || {};
					data.visualObjectum.timeMachine = args.timeMachine;
					storage.visualObjectum.timeMachine = storage.visualObjectum.timeMachine || {};
					var dates = storage.visualObjectum.timeMachine.dates;
					storage.visualObjectum.timeMachine = args.timeMachine;
					storage.visualObjectum.timeMachine.dates = dates;
					data.visualObjectum.logo = args.logo;
					storage.visualObjectum.logo = args.logo;
					data.visualObjectum.initAction = args.initAction;
					storage.visualObjectum.initAction = args.initAction;
					storage.redisClient.hdel (storage.code + "-requests", "all");
					data = JSON.stringify (data, null, "\t");
					fs.writeFile (storage.rootDir + "/config.json", data, function (err) {
						cb ();
					});
				};
			});
		}
	], function (err) {
		success ({ok: 1});
	});
};
vo.getSiteMode = function (options) {
	var $o = options.objectum;
	var config = $o.config;
	var async = $o.modules.async;
	var storage = options.storage;
	var success = options.success;
	var args = options.args;
	fs.readFile (storage.rootDir + "/index.html", function (err, data) {
		data = data.toString ("utf8");
		var tokens = data.split ("$o.app.start");
		var posEnd = tokens [1].indexOf ("})") + 2;
		var r = tokens [1].substr (0, posEnd);
		r = eval (r);
		success ({enabled: r.cleanViewport ? 1 : 0});
	});
};
vo.setSiteMode = function (options) {
	var $o = options.objectum;
	var config = $o.config;
	var async = $o.modules.async;
	var storage = options.storage;
	var success = options.success;
	var args = options.args;
	fs.readFile (storage.rootDir + "/index.html", function (err, data) {
		data = data.toString ("utf8");
		var tokens = data.split ("$o.app.start");
		var posEnd = tokens [1].indexOf ("})") + 2;
		var r = tokens [1].substr (0, posEnd);
		r = eval (r);
		r = {
			code: r.code,
			name: r.name,
			version: r.version,
			locale: r.locale,
			visualObjectum: r.visualObjectum
		};
		if (args.enabled) {
			r.cleanViewport = 1;
			r.login = "autologin";
			r.hash = "4739AC0AD2331591E36A0BAE4D401D31DA43C4ED";
		};
		data = tokens [0] + "$o.app.start (" + JSON.stringify (r) + ")" + tokens [1].substr (posEnd);
		fs.writeFile (storage.rootDir + "/index.html", data, function (err) {
			success ({ok: 1});
		});
	});
};
vo.setProjectBuild = function (options) {
	var $o = options.objectum;
	var config = $o.config;
	var async = $o.modules.async;
	var storage = options.storage;
	var success = options.success;
	var args = options.args;
	var jar;
	async.series ([
		function (cb) {
			fs.exists (storage.rootDir + "/../app/plugins/compiler.jar", function (exists) {
				if (exists) {
					jar = storage.rootDir + "/../app/plugins/compiler.jar";
					cb ();
				} else {
					fs.exists (storage.rootDir + "/plugins/compiler.jar", function (exists) {
						if (exists) {
							jar = storage.rootDir + "/plugins/compiler.jar";
							cb ();
						} else {
							cb ("compiler.jar not exists.");
						}
					});
				}
			});
		},
		function (cb) {
			fs.unlink (storage.rootDir + "/resources/scripts/vo.js", function (err) {
				var spawn = require ("child_process").spawn;
				var cp = spawn ("java", [
					"-jar", jar, 
					"--js", storage.rootDir + "/resources/scripts/vo-debug.js", 
					"--js_output_file", storage.rootDir + "/resources/scripts/vo.js"
				]);
				var err = "";
				cp.stderr.on ("data", function (data) {
					err += data;
				});				
				cp.on ("close", function (code) {
					cb (err);
				});				
			});
		},
		function (cb) {
			if (args.build == "prod") {
				fs.exists (storage.rootDir + "/resources/scripts/vo.js", function (exists) {
					if (exists) {
						cb ();
					} else {
						cb ("vo.js not exists.");
					}
				});
			} else {
				cb ();
			};
		}
	], function (err) {
		var js = "vo-debug.js";
		if (args.build == "prod" && !err) {
			js = "vo.js";
		};
		fs.readFile (storage.rootDir + "/index.html", function (err3, data) {
			data = data.toString ("utf8");
			var tokens = data.split ("/client/extjs4/vo-debug.js");
			if (tokens.length == 1) {
				tokens = data.split ("/client/extjs4/vo.js");
			};
			data = tokens.join ("/client/extjs4/" + js);
			tokens = data.split ("resources/scripts/vo-debug.js");
			if (tokens.length == 1) {
				tokens = data.split ("resources/scripts/vo.js");
			};
			data = tokens.join ("resources/scripts/" + js);
			fs.writeFile (storage.rootDir + "/index.html", data, function (err2) {
				success (err ? {err: err} : {ok: 1});
			});
		});
	});
};
exports.vo = vo;
